<script setup lang="ts">
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import { RoleEnum, type UserOutExtended } from "@/client/types.gen.ts";
import { useUserStore } from "@/stores";
import dayjs from "dayjs";
import BootstrapToast from "@/components/BootstrapToast.vue";
import { Toast } from "bootstrap";
import { onBeforeMount, onMounted, reactive, watch } from "vue";

const props = defineProps<{
  modalId: string;
  user?: UserOutExtended;
}>();
let errorToast: Toast | undefined;
let successToast: Toast | undefined;

const roleState = reactive<{
  errorMessage: string;
  updatedName: string;
  editing: boolean;
  loading: boolean;
  roles: RoleEnum[];
}>({
  errorMessage: "",
  updatedName: "",
  editing: false,
  loading: false,
  roles: [],
});

const userRepository = useUserStore();
watch(
  () => props.user,
  (newVal, oldVal) => {
    if (newVal != oldVal) {
      resetRoles(newVal);
    }
  },
);

const emit = defineEmits<{
  (e: "rolesUpdated", uid: string, roles: RoleEnum[]): void;
}>();

function saveUserRoles() {
  if (props.user) {
    roleState.loading = true;
    roleState.updatedName = props.user.display_name;
    userRepository
      .updateUserRoles(props.user.uid, roleState.roles)
      .then((user) => {
        emit("rolesUpdated", user.uid, user.roles);
        roleState.editing = false;
        successToast?.show();
      })
      .catch((err) => {
        roleState.errorMessage = err.response?.data?.["detail"];
        errorToast?.show();
      })
      .finally(() => {
        roleState.loading = false;
      });
  }
}

function resetRoles(user?: UserOutExtended) {
  roleState.editing = false;
  roleState.loading = false;
  roleState.roles = user?.roles ?? [];
}

function editRoles() {
  roleState.editing = true;
}

function modalHidden() {
  resetRoles(props.user);
}

onBeforeMount(() => {
  resetRoles(props.user);
});

onMounted(() => {
  successToast = new Toast("#change-role-success-toast");
  errorToast = new Toast("#change-role-error-toast");
});
</script>

<template>
  <bootstrap-toast toast-id="change-role-success-toast">
    Successfully change roles of user {{ roleState.updatedName }}
  </bootstrap-toast>
  <bootstrap-toast toast-id="change-role-error-toast" color-class="danger">
    <template #default
      >Couldn't change the roles of
      {{ roleState.updatedName }}
    </template>
    <template #body>Error: {{ roleState.errorMessage }}</template>
  </bootstrap-toast>
  <bootstrap-modal
    :modal-id="modalId"
    modal-label="User Detail Modal"
    size-modifier-modal="lg"
    v-on="{ 'hidden.bs.modal': modalHidden }"
  >
    <template #header>
      <h4>
        Details for <i>{{ props.user?.display_name }}</i>
      </h4>
    </template>
    <template #body>
      <h5>General</h5>
      <div
        class="d-flex justify-content-start align-items-center column-gap-4 mb-2"
      >
        <div class="w-fit">
          <img
            v-if="props.user"
            :src="props.user.gravatar_url + '?d=mp&s=128'"
            class="rounded-circle img-fluid"
            height="128"
            width="128"
            alt="profile picture"
          />
        </div>
        <div>
          Name: {{ props.user?.display_name }}<br />
          Email:
          <a v-if="props.user?.email" :href="`mailto:${props.user.email}`">{{
            props.user.email
          }}</a
          ><span v-else>-</span><br />
          CloWM ID: {{ props.user?.uid }}<br />
          <span v-if="props.user?.last_login"
            >Last Login:
            {{
              dayjs.unix(props.user.last_login).format("MMM DD, YYYY HH:mm:ss")
            }}</span
          >
        </div>
      </div>
      <h5>Linked Accounts</h5>
      <h6>LifeScience</h6>
      <div class="form-check">
        <input
          id="user-details-lifesicence-id"
          type="checkbox"
          class="form-check-input"
          :checked="props.user?.lifescience_id != undefined"
          disabled
        />
        <label
          class="form-check-label opacity-100"
          for="user-details-lifesicence-id"
        >
          <template v-if="props.user?.lifescience_id"
            >{{ props.user?.lifescience_id }}&#x200B;@lifescience-ri.eu
          </template>
          <template v-else>-</template>
        </label>
      </div>
      <h6>IAM4NFDI</h6>
      <div class="form-check">
        <input
          id="user-details-nfdi-id"
          type="checkbox"
          class="form-check-input"
          :checked="props.user?.nfdi_id != undefined"
          disabled
        />
        <label class="form-check-label opacity-100" for="user-details-nfdi-id">
          <template v-if="props.user?.nfdi_id"
            >{{ props.user?.nfdi_id }}
          </template>
          <template v-else>-</template>
        </label>
      </div>
      <h4>Roles</h4>
      <div
        v-for="role in Object.values(RoleEnum)"
        :key="role"
        class="form-check"
      >
        <input
          :id="`user-details-roles-${role}`"
          v-model="roleState.roles"
          type="checkbox"
          class="form-check-input"
          :value="role"
          :disabled="!roleState.editing || roleState.loading"
        />
        <label
          class="form-check-label opacity-100 text-uppercase"
          :for="`user-details-roles-${role}`"
        >
          {{ role }}
        </label>
      </div>
    </template>
    <template #footer>
      <button
        v-if="!roleState.editing"
        type="button"
        class="btn btn-secondary"
        :disabled="roleState.loading"
        @click="editRoles"
      >
        Edit Roles
      </button>
      <div v-if="roleState.editing" class="btn-group" role="group">
        <button
          type="button"
          class="btn btn-success"
          :disabled="roleState.loading"
          @click="saveUserRoles"
        >
          Save
        </button>
        <button
          type="button"
          class="btn btn-danger"
          :disabled="roleState.loading"
          @click="modalHidden"
        >
          Discard
        </button>
      </div>
      <button
        type="button"
        class="btn btn-secondary"
        data-bs-dismiss="modal"
        :disabled="roleState.loading"
        :hidden="roleState.editing"
      >
        Close
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
